#!/usr/bin/perl

use strict; 

print "running circuits from SC_6 folder\n";
print "circuit, region_place_count, grid size, bbox, crit delay, run time (s)\n";

my @files = <./SC_6/*.net>;
my $numoffiles = @files;
my $stdout;

#for (my $count1 = 30; $count1 <= 270 ; $count1+=30){
my $count1 = 90;
for (my $count = 0; $count < $numoffiles; $count++){
		  $stdout = `./vpr $files[$count] real_arch.xml place.out route.out -place_only -nodisp -region_place_count $count1`;
		  my @lines = split(/\n/, $stdout);
		  my $numoflines = @lines;

		  #parse output
		print "$files[$count], $count1,";  
		for (my $count2 = 0; $count2 < $numoflines; $count2++){
					 if ($lines[$count2] =~ /recomputed from scratch is (\S+)\./){
								print "$1,";
					 }	  
					 elsif ($lines[$count2] =~ /The circuit will be mapped into a (\d+) x (\d+) array of clbs./){
								print "$1 x $2,";
					 }	  
					 elsif ($lines[$count2] =~ /Placement Estimated Crit Path Delay: (\S+)/){
								print "$1,";
					 }
					 elsif ($lines[$count2] =~ /inner loop wall: (\S+) sec,/){
								print "$1,";
					 }
		  }
		  print "\n";

}
#}
